<?php
// $Id:

/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


function pe_course_registration_home() {
  global $user;
  //pe_programs/registration/34/6/78
  $faculty_officer = arg(2);
  $course_adviser = arg(3);
  $student = arg(4);
  
  $acad_year = _load_acad_year();

	if(variable_get('do_registration', TRUE) != 1) {
		return t('No registration process.');
	}
	
	if(($acad_year->is_acad_registration_period) || ($acad_year->is_acad_registration_late)) { 
		
		if($acad_year->is_acad_registration_late) {
			drupal_set_message(t('Late registration.'));
		}
		
		if(($user->uid == 1) || ($user->is_secretary)) {
			$sec_uid = ($user->is_secretary) ? $user->uid : '';
			$output = _secretary_registration_home($sec_uid);
		}
		elseif($user->is_faculty_officer) {
			
		}
		elseif($user->is_course_adviser) {
			
		}
		elseif($user->is_student) {
			
		}		
		else {
			drupal_goto('pe_programs');
		}		
	}
	else {
		$output = ($acad_year->is_acad_registration_too_early) ? t('Registration has not started yet.') : t('Registration has closed.');
		return $output;
	}
	return $output;
}



function _secretary_registration_home($sec_uid) {
	global $user, $conf;
	
	$profiles = array(
    'profile' => array('field_firstname','field_lastname', 'field_personal_title', 'field_gender'), 
  );

  $pfields = _get_profile_fields_sql($profiles);
  
  $query = '';
  $query .= "SELECT profile.nid, ou2.uid AS faculty_officer_uid, u1.name, ". implode(', ', $pfields['selects']) .", COUNT(DISTINCT ou1.uid) AS total_advisers, COUNT(ou4.uid) AS total_students \n";
  $query .= " FROM ({users} u1, {node} profile, {{og_uid}} ou1, {node} n1, {node} n2) \n";
  $query .= " LEFT JOIN {og_uid} ou2 ON (ou1.nid = ou2.nid) \n";
  $query .= " LEFT JOIN {og_uid} ou3 ON (ou1.uid = ou3.uid) \n";
  $query .= " LEFT JOIN {og_uid} ou4 ON (ou3.nid = ou4.nid) \n";
  $query .= implode("\n", $pfields['joins']) ." \n";
  $query .= " WHERE ou1.is_admin <> %d \n";
  $query .= " AND n1.type = '%s' \n";
  $query .= " AND n1.nid = ou1.nid \n";
  $query .= " AND ou2.is_admin = %d \n";
  $query .= " AND ou2.uid <> n1.uid \n";
  $query .= " AND n2.type = '%s' \n";
  $query .= " AND n2.nid = ou3.nid \n";
  $query .= " AND ou3.is_admin = %d \n";
  $query .= " AND ou4.is_admin <> %d \n";
  $query .= " AND profile.type = '%s' \n";
  $query .= " AND profile.uid = ou2.uid \n";
  $query .= " AND ou2.uid = u1.uid \n";
  
  // TODO: give admin role permission
  // secretaries can only see their course advice groups
	if(($sec_uid > 0) && ($user->uid > 1)) {
		$query .= " AND n1.uid = %d";
	}	
  $query .= " GROUP BY ou2.uid, ou1.nid \n";
  
	$args = array();
  $args[] = 1;
  $args[] = variable_get('course_advice_group', 'pe_course_advice');
  $args[] = 1;
  $args[] = variable_get('course_registration_group', 'pe_course_reg');
  $args[] = 1;
  $args[] = 1;
  $args[] = 'profile';
	if(($sec_uid > 0) && ($user->uid > 1)) {
		$args[] = $sec_uid;
	}
	
	$header = array(
    array('data' => t('#')),
    array('data' => t('Name'), 'field' => 'field_lastname,field_firstname'),
    array('data' => t('Gender'), 'field' => 'field_gender'),
    array('data' => t('Total course advisers'), 'field' => 'total_advisers'),
    array('data' => t('Total students'), 'field' => 'total_students'),
    array('data' => t('Operations')),
  );
  
  $show_count = variable_get('items_per_page', 100);
  $tablesort = tablesort_sql($header);
  $result = pager_query($query . $tablesort, $show_count, 0, NULL, $args);
  
  $rows = array();
  $i = 0;
  while($row = db_fetch_object($result)) {
    // mock up user profile
    $account = new stdClass();
    $account->uid = $row->faculty_officer_uid;
    $account->name = $row->name;
    $account->profile->field_lastname[0]['value'] = $row->field_lastname;
    $account->profile->field_firstname[0]['value'] = $row->field_firstname;
    $account->profile->field_personal_title[0]['value'] = _translate_personal_title($row->field_personal_title);
		
		$path = 'pe_programs/registration/'. $row->faculty_officer_uid;
		$attributes = array('title' => t('View groups'));
		
  	$rows[] = array(
  		array('data' => $i + 1, 'align' => 'center'),
  		array('data' => theme('username', $account, $link = 1, $access = 1, $path, $attributes)),
  		array('data' => ($row->field_gender != '') ? theme('image', drupal_get_path('theme', $conf['theme_default']) .'/images/icon_'. drupal_strtolower($row->field_gender) .'.gif')  : '--', 'align' => 'center'),
  		array('data' => $row->total_advisers, 'align' => 'center'),
  		array('data' => $row->total_students, 'align' => 'center'), 
  		array('data' => l(t('Details'), $path, array('attributes' => $attributes)), 'align' => 'center'),		
  	);
    $i++;
  }
  
  if (count($rows) < 1) {
    $rows[] = array(array('data' => t('No faculty officers found.'), 'colspan' => count($header), 'align' => 'center'));
  }
  
  $pager = theme('pager', NULL, $show_count, 0);
  $output .= $pager;
  $output .= theme('table', $header, $rows);
  $output .= $pager;	
  
  return $output;
  	
}


function _get_course_advisers($faculty_officer_uid) {
	global $user;
	$admin = ($faculty_officer_uid > 0) ? $faculty_officer_uid : 0;
	$uids = _get_og_subscriptions(array('pe_course_advice'));
	_printrbox($uids);
	foreach($uids as $uid) {
		
	}
	
}


// get all nids of this $type, created by $manager (secretary),adminstered by $admin (acad staff)
function _get_og_nids($type = array('group'), $admin = NULL, $manager = NULL) {

  $args = array();
  $query = '';
  $query .= " SELECT n.nid FROM {node} n, {og_uid} ou \n";
  $query .= " WHERE n.type IN ('". implode("', '", $type) .") \n";
  $query .= " AND n.uid = ou.nid \n";
  
  if(count($manager) > 0) {
    $query .= " AND n.uid IN (". implode(", ", $manager) .") \n";
  }
  // count() can be true for other data types
  if((is_array($admin)) || (is_array($manager))) {
    $admin_manager = array_merge($admin, $manager);
    $query .= " AND ou.uid IN (". implode(", ", $admin_manager) .") \n";
    $query .= " AND ou.is_admin = %d \n";
    $args[] = 1;
  }
  
  $result = db_query($query);
  $nids = array();
  while ($row = db_fetch_object($result)) {
    $nids[] = $row->nid;
  }
  return $nids;
}



function _get_group_subscriptions($nids = NULL, $is_admin = 0, $is_active = 1) {
  
  if(count($nids) < 1) {
    return;
  }

  $args = array();
  $query = '';
  $query .= " SELECT ou.uid FROM {og_uid} ou WHERE ou.nid IN (". implode(", ", $nids) .") \n";
  // active users only
  if($is_active) {
    $query .= " AND ou.is_active > %d \n";
    $args[] = 0;
  }
   
  // no group admins
  if($is_admin == 0) {
    $query .= " AND ou.is_admin < %d \n";
    $args[] = 1;  
  }

  $result = db_query($query, $args);
  
  $uids = array();
  while($row = db_fetch_object($result)) {
    $uids[] = $row->uid;
  } 
  return $uids;
}


