<?php


class pe_edu_handler_field_program_courses_link extends views_handler_field {
  
  function construct() {
    parent::construct();
    $this->additional_fields['nid'] = 'nid';
  }

  function option_definition() {
    $options = parent::option_definition();

    $options['text'] = array('default' => '', 'translatable' => TRUE);

    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['text'] = array(
      '#type' => 'textfield',
      '#title' => t('Text to display'),
      '#default_value' => $this->options['text'],
    );
  }

  function query() {
    $this->ensure_my_table();
    $this->add_additional_fields();
  }

  function render($values) {   
    $nid = $values->{$this->aliases['nid']};
    return l(t('Courses list'), "pe_programs/courses/$nid", array('title' => t('List of courses for this academic programme')));
  }

}
