<?php


function pe_edu_views_data() {
  
  $data = array();
  
  $data['node']['subsections_link'] = array(
    'title' => t('phpEdu: Subsections link'),
    'help' => t('Generate simple link to subsections'),
    'field' => array(
    'handler' => 'pe_edu_handler_field_subsections_link',
    ),
  );
  $data['node']['program_courses_link'] = array(
    'title' => t('phpEdu: Courses link'),
    'help' => t('Link to list of courses for an academic program'),
    'field' => array(
    'handler' => 'pe_edu_handler_field_program_courses_link',    
    ),
  );
  $data['node']['section_title'] = array(
    'title' => t('phpEdu: Academic section title'),
    'field' => array(
    'handler' => 'pe_edu_handler_field_section_title',
    'help' => t('Academic section title'),
    ),
  );
  $data['node']['studentid'] = array(
    'title' => t('phpEdu: Student ID'),
    'help' => t('Student ID'),
    'field' => array(
    'handler' => 'pe_edu_handler_field_studentid',
    ),
  );
  $data['node']['program_title'] = array(
    'title' => t('phpEdu: Academic programme'),
    'field' => array(
    'handler' => 'pe_edu_handler_field_program_title',
    'help' => t('Academic programme title'),
    ),
  );
  $data['node']['position'] = array(
    'title' => t('phpEdu: Position'),
    'field' => array(
    'handler' => 'pe_edu_handler_field_position',
    'help' => t('Position'),
    ),
  );
  $data['node']['head'] = array(
    'title' => t('phpEdu: Head'),
    'field' => array(
    'handler' => 'pe_edu_handler_field_head',
    'help' => t('Head'),
    ),
  );
  return $data;

}



/**
 * Implementation of hook_views_handlers() to register all of the basic handlers
 * views uses.
 */
function pe_edu_views_handlers() {
  
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'pe_edu') .'/includes',
    ),
    'handlers' => array(
      // field handlers
      'pe_edu_handler_field_subsections_link' => array(
        'parent' => 'views_handler_field',
      ),
      'pe_edu_handler_field_program_courses_link' => array(
        'parent' => 'views_handler_field',
      ),
      'pe_edu_handler_field_section_title' => array(
        'parent' => 'views_handler_field',
      ),
      'pe_edu_handler_field_studentid' => array(
        'parent' => 'views_handler_field',
      ),
      'pe_edu_handler_field_program_title' => array(
        'parent' => 'views_handler_field',
      ),
      'pe_edu_handler_field_position' => array(
        'parent' => 'views_handler_field',
      ),
      'pe_edu_handler_field_head' => array(
        'parent' => 'views_handler_field',
      ),
    ),
  );
  
}
